题目链接:见这里
题意:给出两个只包含小写字母的字符串S 和 T ,S 和 T的字母组成一样但字母顺序可能不同。每次操作可以将 S 中的任意一个字母移到 S的开头或者末尾,求将 S 变成 T的最少操作数。n <= 1000。
分析:下面题解描述来自Wannafly每日题解:
首先我们先得出一个简单的结论,就是每个字符最多挪动一次。如果有需要挪动两次的情况的话,那么通过改变挪动的顺序可以减少挪动次数。基于这个结论,我们将题目转化为最少需要挪动几个字符?然后我们再反向思考一下,将题目变为最多有几个字符可以不动呢?
通过观察我们发现,假定我们选取了若干字符不动,由于操作是将字符放到原串的两端,那么不动的字符最终将会按原来的顺序合并在一起。
这样我们得到了本题的思路即求S和T的最长匹配,要求在S中为子序列,在T中为子串。稍稍修改一下LCS的DP方程就可以了,时间复杂度O(n^2)
代码如下:
//
//Created by BLUEBUFF 2016/1/11
//Copyright (c) 2016 BLUEBUFF.All Rights Reserved
//
#pragma comment(linker,"/STACK:102400000,102400000")
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <cstdio>
#include <time.h>
#include <cstdlib>
#include <cstring>
#include <complex>
#include <sstream> //isstringstream
#include <iostream>
#include <algorithm>
using namespace std;
//using namespace __gnu_pbds;
typedef long long LL;
typedef unsigned long long uLL;
typedef pair<int, LL> pp;
#define REP1(i, a, b) for(int i = a; i < b; i++)
#define REP2(i, a, b) for(int i = a; i <= b; i++)
#define REP3(i, a, b) for(int i = a; i >= b; i--)
#define CLR(a, b) memset(a, b, sizeof(a))
#define MP(x, y) make_pair(x,y)
template <class T1, class T2>inline void getmax(T1 &a, T2 b) { if (b>a)a = b; }
template <class T1, class T2>inline void getmin(T1 &a, T2 b) { if (b<a)a = b; }
const int maxn = 1024;
const int maxm = 1e5+5;
const int maxs = 10;
const int maxp = 1e3 + 10;
const int INF = 1e9;
const int UNF = -1e9;
const int mod = 1e9 + 7;
const int rev = (mod + 1) >> 1; // FWT
//const double PI = acos(-1);
//head
char s1[1005], s2[1005];
int dp[1005][1005];
int main(){
gets(s1 + 1);
gets(s2 + 1);
int ans = 0;
int n = strlen(s1 + 1);
for(int i = 1; i <= n; i++){
for(int j = 1; j <= n; j++){
dp[i][j] = dp[i][j - 1];
if(s1[j] != s2[i]) continue;
getmax(dp[i][j], dp[i - 1][j - 1] + 1);
getmax(ans, dp[i][j]);
}
}
cout << n - ans << endl;
}